---
policy: /ce/ca/aws/elasticache/replication-group-encryption-at-rest
logic: /ce/ca/aws/elasticache/replication-group-encryption-at-rest/prod.logic.yaml
executionTime: 2025-11-17T14:33:35.711675697Z
generationMs: 73
executionMs: 644
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INAPPLICABLE
      actual: INAPPLICABLE
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__status__c') != 'available'
      actual: extract('CA10__status__c') != 'available'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: not(extract('CA10__atRestEncryptionEnabled__c'))
      actual: not(extract('CA10__atRestEncryptionEnabled__c'))
    runtimeError: {}
  - id: test4
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 300
      actual: 300
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/elasticache/replication-group-encryption-at-rest/policy.yaml
    md5Hash: 4FFA2F9F67B2405A5C5E67C431DE18E3
    content: "---\nnames:\n  full: \"AWS ElastiCache Replication Group is not encrypted\
      \ at rest\"\n  contextual: \"Replication Group is not encrypted at rest\"\n\
      description: >\n  Ensure that ElastiCache Replication Groups have encryption\
      \ at rest enabled. \n  This feature encrypts the data stored on disk, including\
      \ backups, using AWS KMS. \n  Enabling encryption at rest adds a critical layer\
      \ of data protection against \n  unauthorized access to the underlying storage.\n\
      type: \"COMPLIANCE_POLICY\"\ncategories:\n  - \"SECURITY\"\nframeworkMappings:\n\
      \  - \"/frameworks/cloudaware/resource-security/data-encryption\"\n  - \"/frameworks/aws-well-architected/sec/08/02\"\
      \n  - \"/frameworks/aws-fsbp-v1.0.0/elasticache/04\"\nsimilarPolicies:\n  awsSecurityHub:\n\
      \    - name: \"[ElastiCache.4] ElastiCache replication groups should be encrypted\
      \ at rest\"\n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/elasticache-controls.html#elasticache-4\""
  - path: /ce/ca/aws/elasticache/replication-group-encryption-at-rest/prod.logic.yaml
    md5Hash: 22747CF0F4111D83AB44D3815D9A5420
    content: |
      ---
      inputType: "CA10__CaAwsCacheReplicationGroup__c"
      testData:
        - file: "test-data.json"
      importExtracts:
        - file: /types/CA10__CaAwsCacheReplicationGroup__c/object.extracts.yaml
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The Replication Group is not available."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__status__c"
              right:
                TEXT: "available"
        - status: "INCOMPLIANT"
          currentStateMessage: "Encryption at rest is not enabled for this replication group."
          remediationMessage: "Encryption at rest must be enabled at creation time.\
            \ A new encrypted replication group must be created from a backup."
          check:
            NOT:
              arg:
                EXTRACT: "CA10__atRestEncryptionEnabled__c"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "Encryption at rest is enabled for this replication group."
  - path: /ce/ca/aws/elasticache/replication-group-encryption-at-rest/test-data.json
    md5Hash: 65B588F72EC9D5C626268C55DC199504
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-10-29T21:59:16Z"
              },
              "CA10__disappearanceTime__c": "2025-08-16T22:44:17Z",
              "CA10__status__c": "deleting",
              "CA10__atRestEncryptionEnabled__c": true,
              "Id": "test1"
          },
          {
              "expectedResult": {
                  "status": "INAPPLICABLE",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__status__c') != 'available'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-10-29T21:59:16Z"
              },
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "creating",
              "CA10__atRestEncryptionEnabled__c": true,
              "Id": "test2"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "not(extract('CA10__atRestEncryptionEnabled__c'))",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-10-29T21:59:16Z"
              },
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "available",
              "CA10__atRestEncryptionEnabled__c": false,
              "Id": "test3"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "300",
                  "conditionText": "otherwise",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-10-29T21:59:16Z"
              },
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "available",
              "CA10__atRestEncryptionEnabled__c": true,
              "Id": "test4"
          }
      ]
  - path: /types/CA10__CaAwsCacheReplicationGroup__c/object.extracts.yaml
    md5Hash: 05D6F73A1FB17B4733BA531296051FB4
    content: "---\nextracts:\n# Values: creating, available, modifying, deleting,\
      \ create-failed, snapshotting.\n# Not nullable. Can't have no access, retrieved\
      \ via elasticache:DescribeReplicationGroups\n  - name: \"CA10__status__c\"\n\
      \    value:\n      FIELD:\n        path: \"CA10__status__c\"\n        undeterminedIf:\n\
      \          isEmpty: \"Corrupted data. Status cannot be empty.\" \n# Checkbox\n\
      \  - name: \"CA10__atRestEncryptionEnabled__c\"\n    value:\n      FIELD:\n\
      \        path: \"CA10__atRestEncryptionEnabled__c\"\n# Checkbox\n  - name: \"\
      CA10__transitEncryptionEnabled__c\"\n    value:\n      FIELD:\n        path:\
      \ \"CA10__transitEncryptionEnabled__c\"\n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INAPPLICABLE",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__status__c') != 'available'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "not(extract('CA10__atRestEncryptionEnabled__c'))",
      "runtimeError" : null
    }
  }, {
    "Id" : "test4",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "300",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsCacheReplicationGroup__c()
  RETURNS ARRAY<STRUCT<
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__status__c STRING,
      CA10__atRestEncryptionEnabled__c BOOLEAN,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-10-29T21:59:16Z")
    },
    "CA10__disappearanceTime__c" : new Date("2025-08-16T22:44:17Z"),
    "CA10__status__c" : "deleting",
    "CA10__atRestEncryptionEnabled__c" : true,
    "Id" : "test1"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-10-29T21:59:16Z")
    },
    "CA10__status__c" : "creating",
    "CA10__atRestEncryptionEnabled__c" : true,
    "Id" : "test2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-10-29T21:59:16Z")
    },
    "CA10__status__c" : "available",
    "CA10__atRestEncryptionEnabled__c" : false,
    "Id" : "test3"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-10-29T21:59:16Z")
    },
    "CA10__status__c" : "available",
    "CA10__atRestEncryptionEnabled__c" : true,
    "Id" : "test4"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsCacheReplicationGroup__c(
      obj STRUCT<
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__status__c STRING,
          CA10__atRestEncryptionEnabled__c BOOLEAN,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__status__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__status__c.isEmpty()", currentStateMessage: "Corrupted data. Status cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__status__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('Status [obj.CA10__status__c]: ' + obj.CA10__status__c);
      try {
          if (TextLib.notEqual(extract3.call(extract3), 'available')) {
              return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__status__c') != 'available'", currentStateMessage: "The Replication Group is not available.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10__atRestEncryptionEnabled__c; } return this.out; };
      references1.push('At Rest Encryption Enabled [obj.CA10__atRestEncryptionEnabled__c]: ' + obj.CA10__atRestEncryptionEnabled__c);
      if (!extract6.call(extract6)) {
          return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "not(extract('CA10__atRestEncryptionEnabled__c'))", currentStateMessage: "Encryption at rest is not enabled for this replication group.", currentStateReferences: references1.join('\n'), remediation: "Encryption at rest must be enabled at creation time. A new encrypted replication group must be created from a backup.", runtimeError: null};
      }
      return {status: 'COMPLIANT', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "Encryption at rest is enabled for this replication group.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__status__c AS CA10__status__c,
          sObject.CA10__atRestEncryptionEnabled__c AS CA10__atRestEncryptionEnabled__c,
          sObject.Id AS Id,
          process_CA10__CaAwsCacheReplicationGroup__c(
              STRUCT(
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__status__c AS CA10__status__c,
                  sObject.CA10__atRestEncryptionEnabled__c AS CA10__atRestEncryptionEnabled__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsCacheReplicationGroup__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
